"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var tsconfig_paths_webpack_plugin_1 = tslib_1.__importDefault(require("tsconfig-paths-webpack-plugin"));
var disableCaching = String(process.env.BUILD_CACHE_DISABLED).toLowerCase() === 'true';
var cacheLoader = function (cacheDirectory) {
    return {
        loader: 'cache-loader',
        options: {
            cacheDirectory: cacheDirectory,
        },
    };
};
function getTypeScriptWebpackRule(_plugins, resolvePlugins, options, buildTarget) {
    var configFile = (buildTarget === 'server'
        ? options.buildConfig.TS_CONFIG_SERVER
        : options.buildConfig.TS_CONFIG_CLIENT) || 'tsconfig.json';
    options.log.info("Target " + buildTarget + " using ts config file: " + configFile);
    var tsConfigPathsPluginConfig = {};
    var tsLoaderOptions = {
        compilerOptions: {
            noEmit: false,
        },
    };
    if (configFile) {
        tsConfigPathsPluginConfig.configFile = configFile;
        tsLoaderOptions.configFile = configFile;
    }
    resolvePlugins.push(new tsconfig_paths_webpack_plugin_1.default(tsConfigPathsPluginConfig));
    var tsLoader = {
        loader: 'ts-loader',
        options: tsLoaderOptions,
    };
    return {
        test: /\.tsx?$/,
        use: !disableCaching ? [cacheLoader(options.cacheDirectory), tsLoader] : [tsLoader],
    };
}
exports.getTypeScriptWebpackRule = getTypeScriptWebpackRule;
//# sourceMappingURL=ts-loader-config.js.map